it-swarm-eu.dev

Jak zkontrolovat heslo v systému Linux?

Chci zkontrolovat, z linuxového příkazového řádku, zda dané heslo pro jasný text je stejné jako šifrované heslo na/etc/shadow

(Potřebuji to k ověření uživatelů webu. Používám vestavěný linux.)

Mám přístup k samotnému souboru/etc/shadow.

23
michelemarcon

Šifrované heslo můžete snadno extrahovat pomocí awk. Potom musíte extrahovat předponu $algorithm$salt$ (za předpokladu, že tento systém nepoužívá tradiční DES, který je silně zastaralý, protože v dnešní době může být hrubě nucen).

correct=$(</etc/shadow awk -v user=bob -F : 'user == $1 {print $2}')
prefix=${correct%"${correct#\$*\$*\$}"}

Pro kontrolu hesla je základní funkcí C crypt , ale neexistuje žádný standardní příkaz Shell pro přístup k této položce.

Na příkazovém řádku můžete použít Perl jednoplášťové volání k vyvolání crypt na heslo.

supplied=$(echo "$password" |
           Perl -e '$_ = <STDIN>; chomp; print crypt($_, $ARGV[0])' "$prefix")
if [ "$supplied" = "$correct" ]; then …

Protože to nelze provést pomocí čistých nástrojů Shell, pokud máte Perl k dispozici, můžete to také udělat v Perlu. (Nebo Python, Ruby,… ať už máte k dispozici cokoli, co může volat funkci crypt) Varování, netestovaný kód.

#!/usr/bin/env Perl
use warnings;
use strict;
my @pwent = getpwnam($ARGV[0]);
if ([email protected]) {die "Invalid username: $ARGV[0]\n";}
my $supplied = <STDIN>;
chomp($supplied);
if (crypt($supplied, $pwent[1]) eq $pwent[1]) {
    exit(0);
} else {
    print STDERR "Invalid password for $ARGV[0]\n";
    exit(1);
}

Na vestavěném systému bez Perlu bych použil malý vyhrazený program C. Varování, napsané přímo do prohlížeče, jsem se ani nepokusil zkompilovat. To má ilustrovat nezbytné kroky, nikoli jako robustní implementaci!

/* Usage: echo password | check_password username */
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <shadow.h>
#include <sys/types.h>
#include <unistd.h>
int main(int argc, char *argv[]) {
    char password[100];
    struct spwd shadow_entry;
    char *p, *correct, *supplied, *salt;
    if (argc < 2) return 2;
    /* Read the password from stdin */
    p = fgets(password, sizeof(password), stdin);
    if (p == NULL) return 2;
    *p = 0;
    /* Read the correct hash from the shadow entry */
    shadow_entry = getspnam(username);
    if (shadow_entry == NULL) return 1;
    correct = shadow_entry->sp_pwdp;
    /* Extract the salt. Remember to free the memory. */
    salt = strdup(correct);
    if (salt == NULL) return 2;
    p = strchr(salt + 1, '$');
    if (p == NULL) return 2;
    p = strchr(p + 1, '$');
    if (p == NULL) return 2;
    p[1] = 0;
    /*Encrypt the supplied password with the salt and compare the results*/
    supplied = crypt(password, salt);
    if (supplied == NULL) return 2;
    return !!strcmp(supplied, correct);
}

Jiným přístupem je použití existujícího programu, například su nebo login. Ve skutečnosti, pokud je to možné, by bylo ideální zajistit, aby webová aplikace prováděla vše, co potřebuje prostřednictvím su -c somecommand username. Potíž je zde přiložit heslo k su; to vyžaduje terminál. Obvyklý nástroj pro emulaci terminálu je očekávejte , ale je to velká závislost pro vestavěný systém. I když je su v BusyBoxu, je často vynechán, protože mnoho jeho použití vyžaduje, aby byl binární blok BusyBox nastaven jako root. Přesto, pokud to dokážete, je to nejpevnější přístup z hlediska bezpečnosti.

Podívejte se na man 5 shadow a man 3 crypt. Z toho se můžete dozvědět, že heslo hashuje v /etc/shadow mají následující podobu:

 $id$salt$encrypted

kde id definuje typ šifrování a při dalším čtení může být jedním z

          ID  | Method
          ---------------------------------------------------------
          1   | MD5
          2a  | Blowfish (not in mainline glibc; added in some
              | Linux distributions)
          5   | SHA-256 (since glibc 2.7)
          6   | SHA-512 (since glibc 2.7)

V závislosti na typu hashe musíte použít příslušnou funkci/nástroj pro generování a ověření hesla „ručně“. Pokud systém obsahuje program mkpasswd, můžete jej použít jak je zde navrženo . (Pokud to nebylo zřejmé, odeberete sůl ze stínového souboru.) Například pomocí md5 hesla:

 mkpasswd -5 <the_salt> <the_password>

vygeneruje řetězec, který by měl odpovídat /etc/shadow záznam.

6
rozcietrzewiacz

Byla podobná otázka byla položena na Stack Overflow . cluelessCoder poskytl skript pomocí očekávání , který můžete nebo nemusíte mít na svém vestavěném systému.

#!/bin/bash
#
# login.sh $USERNAME $PASSWORD

#this script doesn't work if it is run as root, since then we don't have to specify a pw for 'su'
if [ $(id -u) -eq 0 ]; then
        echo "This script can't be run as root." 1>&2
        exit 1
fi

if [ ! $# -eq 2 ]; then
        echo "Wrong Number of Arguments (expected 2, got $#)" 1>&2
        exit 1
fi

USERNAME=$1
PASSWORD=$2

#since we use expect inside a bash-script, we have to escape tcl-$.
expect << EOF
spawn su $USERNAME -c "exit" 
expect "Password:"
send "$PASSWORD\r"
#expect eof

set wait_result  [wait]

# check if it is an OS error or a return code from our command
#   index 2 should be -1 for OS erro, 0 for command return code
if {[lindex \$wait_result 2] == 0} {
        exit [lindex \$wait_result 3]
} 
else {
        exit 1 
}
EOF
1
mr.Shu

Nezapomeňte, že za předpokladu, že je systém správně nakonfigurován, bude nutné program spustit jako root.

Lepším řešením než přímé čtení stínového souboru a psaní vlastního kódu kolem krypty by bylo pouhé použití vazeb pam.

Tarbal squid přicházel s jednoduchým nástrojem CLI pro ověřování uživatelských jmen/hesel pomocí stdio - tak snadné se přizpůsobit pomocí argumentů - ačkoli verze, kterou jsem hacknul, byla pro strukturované programování jen stěží pin-up plakátem . Rychlý google a vypadá to, že novější verze byly významně vyčištěny, ale stále je tam několik 'goto'.

0
symcbean
#! /bin/bash
#  (GPL3+) Alberto Salvia Novella (es20490446e)


passwordHash () {
    password=${1}
    salt=${2}
    encryption=${3}

    hashes=$(echo ${password} | openssl passwd -${encryption} -salt ${salt} -stdin)
    echo $(substring ${hashes} "$" "3")
}


passwordIsValid () {
    user=${1}
    password=${2}

    encryption=$(secret "encryption" ${user})
    salt=$(secret "salt" ${user})
    salted=$(secret "salted" ${user})
    hash=$(passwordHash ${password} ${salt} ${encryption})

    [ ${salted} = ${hash} ] && echo "true" || echo "false"
}


secret () {
    secret=${1}
    user=${2}
    shadow=$(shadow ${user})

    if [ ${secret} = "encryption" ]; then
        position=1
    Elif [ ${secret} = "salt" ]; then
        position=2
    Elif [ ${secret} = "salted" ]; then
        position=3
    fi

    echo $(substring ${shadow} "$" ${position})
}


shadow () {
    user=${1}
    shadow=$(cat /etc/shadow | grep ${user})
    shadow=$(substring ${shadow} ":" "1")
    echo ${shadow}
}


substring () {
    string=${1}
    separator=${2}
    position=${3}

    substring=${string//"${separator}"/$'\2'}
    IFS=$'\2' read -a substring <<< "${substring}"
    echo ${substring[${position}]}
}


passwordIsValid ${@}